function [h] = gen_h(Y, X, beta, N, m, v)

     e_vec = Y - X*beta;

     % Parameters for Gamma distribution describing conditional posterior distribution for error precision h = 1/sig2 -> Gamma(mbar,vbar)

     vbar = N + v;
     mbar = vbar/(e_vec'*e_vec + v/m);
     
     % The following converts mbar and vbar into the definition of the gamma definition used by Matlab random number generator (gamrnd), Gamma(a,b). 
     % In this paramterization of Gamma, E(h) = a*b and Var(h) = a*b^2.  a is called the shape parameter and b the scale parameter.     

     a = vbar/2;
     b = mbar/a;
     
     h = gamrnd(a,b); %h is a draw from the posterior for the error precision
    
end